import {CHARS} from '@mathjax/font-tools/js/CharMap.js';
import {Font} from '@mathjax/font-tools/js/Font.js';
import {Variants} from '@mathjax/font-tools/js/Variant.js';
import {Delimiters} from '@mathjax/font-tools/js/Delimiters.js';
import {CommonFont, FontDef} from '@mathjax/font-tools/js/CommonFont.js';
import {SVGFont} from '@mathjax/font-tools/js/SVGFont.js';
import {CHTMLFont} from '@mathjax/font-tools/js/CHTMLFont.js';
import {Components} from '@mathjax/font-tools/js/Components.js';
import {SIL_LICENSE, SIL_URL} from '@mathjax/font-tools/js/Subset.js';

/***********************************************************************************/

try {

  Font.load({
    'TEX-N':   'fonts/MathJax_Main-Regular.otf',
    'TEX-B':   'fonts/MathJax_Main-Bold.otf',
    'TEX-I':   'fonts/MathJax_Math-Italic.otf',
    'TEX-MI':  'fonts/MathJax_Main-Italic.otf',
    'TEX-BI':  'fonts/MathJax_Math-BoldItalic.otf',
    'TEX-S1':  'fonts/MathJax_Size1-Regular.otf',
    'TEX-S2':  'fonts/MathJax_Size2-Regular.otf',
    'TEX-S3':  'fonts/MathJax_Size3-Regular.otf',
    'TEX-S4':  'fonts/MathJax_Size4-Regular.otf',
    'TEX-A':   'fonts/MathJax_AMS-Regular.otf',
    'TEX-C':   'fonts/MathJax_Calligraphic-Regular.otf',
    'TEX-CB':  'fonts/MathJax_Calligraphic-Bold.otf',
    'TEX-FR':  'fonts/MathJax_Fraktur-Regular.otf',
    'TEX-FRB': 'fonts/MathJax_Fraktur-Bold.otf',
    'TEX-SS':  'fonts/MathJax_SansSerif-Regular.otf',
    'TEX-SSB': 'fonts/MathJax_SansSerif-Bold.otf',
    'TEX-SSI': 'fonts/MathJax_SansSerif-Italic.otf',
    'TEX-SC':  'fonts/MathJax_Script-Regular.otf',
    'TEX-T':   'fonts/MathJax_Typewriter-Regular.otf',
    'TEX-V':   'fonts/MathJax_Vector-Regular.otf',
    'TEX-VB':  'fonts/MathJax_Vector-Bold.otf'
  });

  Font.get('TEX-N')
    .addGlyph(Font.buildH('TEX-N', [0x2190, [0x2223, 'TEX-S1.']], 0x21A4, 'uni21A4', [0, -100], [0, -50], -90))
    .addGlyph(Font.buildV('TEX-N', [0x005F, 0x2191], 0x21A5, 'uni21A5', [10, 130]))
    .addGlyph(Font.buildV('TEX-N', [0x2193, 0x005F], 0x21A7, 'uni21A7', [140, -130]))
    .addGlyph(Font.buildH('TEX-S4', [0xE150, 0xE153, 0xE152, 0xE151], 0x23DE, 'uni23DE'))
    .addGlyph(Font.buildH('TEX-S4', [0xE152, 0xE151, 0xE150, 0xE153], 0x23DF, 'uni23DF'))
    .addGlyph(Font.buildH('TEX-N', [0x2190, 0x2212, [0x2223, 'TEX-S1.']], 0x27FB, 'uni27FB',
                          [0, -90, -110], [0, 0, -50], -90))
    .addGlyph(Font.buildH('TEX-N', [0x21D0, 0x003D, [0x2223, 'TEX-S1.']], 0x27FD, 'uni27FD',
                          [0, -90, -85], [0, 0, -50], -90))
    .addGlyph(Font.buildH('TEX-N', [[0x2223, 'TEX-S1.'], 0x003D, 0x21D2], 0x27FE, 'uni27FE',
                          [-90, -170, -90], [-50, 0, 0]))
    .addGlyph(Font.buildH('TEX-N', [0x21D0, [0x2223, 'TEX-S1.']], 0x2906, 'uni2906', [0, -85], [0, -50], -90))
    .addGlyph(Font.buildH('TEX-N', [[0x2223, 'TEX-S1.'], 0x21D2], 0x2907, 'uni2907', [-90, -170], [-50, 0]))
    .addGlyph(Font.buildH('TEX-N', [0x21BC, 0x21C1], 0x294A, 'uni294A', [0, -800]))
    .addGlyph(Font.buildH('TEX-N', [0x21BD, 0x21C0], 0x294B, 'uni294B', [0, -800]))
    .addGlyph(Font.buildV('TEX-A', [0x21C3, 0x21BE], 0x294C, 'uni294C', [0, -800]))
    .addGlyph(Font.buildV('TEX-A', [0x21C2, 0x21BF], 0x294D, 'uni294D', [0, -800]))
    .addGlyph(Font.buildH('TEX-N', [0x21BC, 0x21C0], 0x294E, 'uni294E', [0, -800]))
    .addGlyph(Font.buildV('TEX-A', [0x21C2, 0x21BE], 0x294F, 'uni294F', [0, -800]))
    .addGlyph(Font.buildH('TEX-N', [0x21BD, 0x21C1], 0x2950, 'uni2950', [0, -800]))
    .addGlyph(Font.buildV('TEX-A', [0x21C3, 0x21BF], 0x2951, 'uni2951', [0, -800]))
    .addGlyph(Font.buildH('TEX-N', [0x21BC, [0x2223, 'TEX-S1.']], 0x295A, 'uni295A', [0, -85], [0, -50], -90))
    .addGlyph(Font.buildH('TEX-N', [[0x2223, 'TEX-S1.'], 0x21C0], 0x295B, 'uni295B', [-90, -170], [-50, 0]))
    .addGlyph(Font.buildV('TEX-N', [0x005F, [0x21BE, 'TEX-A.']], 0x295C, 'uni295C', [0, 130], [0, 42]))
    .addGlyph(Font.buildV('TEX-N', [[0x21C2, 'TEX-A.'], 0x005F], 0x295D, 'uni295D', [140, -130], [42, 0]))
    .addGlyph(Font.buildH('TEX-N', [0x21BD, [0x2223, 'TEX-S1.']], 0x295E, 'uni295E', [0, -85], [0, -50], -90))
    .addGlyph(Font.buildH('TEX-N', [[0x2223, 'TEX-S1.'], 0x21C1], 0x295F, 'uni295F', [-90, -170], [-50, 0]))
    .addGlyph(Font.buildV('TEX-N', [0x005F, [0x21BF, 'TEX-A.']], 0x2960, 'uni2960', [0, 130], [0, 42]))
    .addGlyph(Font.buildV('TEX-N', [[0x21C3, 'TEX-A.'], 0x005F], 0x2961, 'uni2961', [140, -130], [42, 0]))
    .addGlyph(Font.buildH('TEX-N', [0x02D9, 0x02D9, 0x02D9], 0x20DB, 'uni20DB', [-100, -110, -110], 0, -100))
    .addGlyph(Font.buildH('TEX-N', [0x02D9, 0x02D9, 0x02D9, 0x02D9], 0x20DC, 'uni20DC',
                          [-100, -110, -110, -110], 0, -100))
  ;

  Font.get('TEX-S1')
    .addGlyph(Font.buildH('TEX-N', [0x2212], 0x2190, 'uni2190', -84, 0, -84))
    .addGlyph(Font.buildH('TEX-N', [0x2192], 0x2192, 'uni2192', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-N', [0x2190], 0x2194, 'uni2194', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-A', [0x219E], 0x219E, 'uni219E', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-A', [0x21A0], 0x21A0, 'uni21A0', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-N', [0x21D2], 0x21D2, 'uni21D2', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-N', [0x21D0], 0x21D4, 'uni21D4', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-N', [0x21BC], 0x21BC, 'uni21BC', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-N', [0x21BD], 0x21BD, 'uni21BD', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-S1', [0x2223], 0x21BE, 'uni21BE', 42, 0, 42))
    .addGlyph(Font.buildH('TEX-N', [0x21C0], 0x21C0, 'uni21C0', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-N', [0x21C1], 0x21C1, 'uni21C1', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-S1', [0x2223], 0x21A4, 'uni21A4', -145, -50, -145))
    .addGlyph(Font.buildH('TEX-N', [0x003D], 0x21D0, 'uni21D0', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-A', [0x21DA], 0x21DA, 'uni21DA', -76, 0, -55))
    .addGlyph(Font.buildH('TEX-A', [0x21DB], 0x21DB, 'uni21DB', -55, 0, -76))
    .addGlyph(Font.buildH('TEX-N', [0x2212], 0x2212, 'uni2212', -84, 0, -84))
    .addGlyph(Font.buildH('TEX-N', [0x2261], 0x2261, 'uni2261', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-N', [0x2212], 0x23B4, 'uni23B4', 0, 424))
    .addGlyph(Font.buildH('TEX-N', [0x2212], 0x23B5, 'uni23B5', 0, -252))
    .addGlyph(Font.buildH('TEX-N', [0x003D], 0x2906, 'uni2906', -55, 0, -55))
    .addGlyph(Font.buildH('TEX-S1', [0x2223], 0x294C, 'uni294C', 82, 0, 82))
    .addGlyph(Font.buildH('TEX-S1', [0x222C, 0x222C], 0x2A0C, 'uni2A0C', [0, -70]))
  ;

  /***********************************************************************************/

  const MathJaxTexVariants = Variants.define({
    'normal': [
      ['TEX-N', [
        CHARS.Range(0x0020, 0x007E),
        CHARS.Range(0x00AF, 0x00B1),
        CHARS.Range(0x02C9, 0x02CB),
        CHARS.Range(0x02D8, 0x02DA),
        CHARS.Range(0x0300, 0x0304),
        CHARS.Range(0x0306, 0x0308),
        CHARS.Range(0x030A, 0x030C),
        CHARS.Range(0x2190, 0x2199),
        CHARS.Range(0x21D0, 0x21D5),
        CHARS.Range(0x2207, 0x2209),
        CHARS.Range(0x2215, 0x221A),
        CHARS.Range(0x2227, 0x222B),
        CHARS.Range(0x2291, 0x2299),
        CHARS.Range(0x22A2, 0x22A5),
        CHARS.Range(0x22C4, 0x22C6),
        CHARS.Range(0x2308, 0x230B),
        CHARS.Range(0x2660, 0x2663),
        CHARS.Range(0x266D, 0x266F),
        CHARS.Range(0x27F5, 0x27FA),
        CHARS.At(
          0x00A0, 0x00A8, 0x00AC, 0x00B4, 0x00D7, 0x00F7, 0x0131, 0x0237, 0x02C6, 0x02C7,
          0x02DC, 0x0338, 0x0393, 0x0394, 0x0398, 0x039B, 0x039E, 0x03A0, 0x03A3, 0x03A5,
          0x03A6, 0x03A8, 0x03A9, 0x2013, 0x2014, 0x2018, 0x2019, 0x201C, 0x201D, 0x2020,
          0x2021, 0x2026, 0x2032, 0x20DB, 0x20DC, 0x2113, 0x2118, 0x2135, 0x21A6, 0x21A9,
          0x21AA, 0x21BC, 0x21BD, 0x21C0, 0x21C1, 0x21CC, 0x2200, 0x2202, 0x2203, 0x2205,
          0x220B, 0x2212, 0x2213, 0x221D, 0x221E, 0x2220, 0x2223, 0x2225, 0x223C, 0x2240,
          0x2243, 0x2245, 0x2248, 0x224D, 0x2250, 0x2260, 0x2261, 0x2264, 0x2265, 0x226A,
          0x226B, 0x227A, 0x227B, 0x2282, 0x2283, 0x2286, 0x2287, 0x228E, 0x22A8, 0x22C8,
          0x22EE, 0x22EF, 0x22F1, 0x2322, 0x2323, 0x23B0, 0x23B1, 0x25B3, 0x25B9, 0x25BD,
          0x25C3, 0x25EF, 0x27E8, 0x27E9, 0x27EE, 0x27EF, 0x27FC, 0x2A3F, 0x2AAF, 0x2AB0,
          0x21A4, 0x21A5, 0x21A7, 0x23DE, 0x23DF, 0x27FB, 0x27FD, 0x27FE, 0x2906, 0x2907,
          0x294A, 0x294B, 0x294C, 0x294D, 0x294E, 0x294F, 0x2950, 0x2951, 0x295A, 0x295B,
          0x295C, 0x295D, 0x295E, 0x295F, 0x2960, 0x2961
        ),
        CHARS.Map({
          0x00B7: 0x22C5, 0x02B9: 0x2032, 0x0391: 0x0041, 0x0392: 0x0042, 0x0395: 0x0045,
          0x0396: 0x005A, 0x0397: 0x0048, 0x0399: 0x0049, 0x039A: 0x004B, 0x039C: 0x004D,
          0x039D: 0x004E, 0x039F: 0x004F, 0x03A1: 0x0050, 0x03A4: 0x0054, 0x03A7: 0x0058,
          0x2015: 0x2014, 0x2016: 0x2225, 0x2017: 0x005F, 0x2022: 0x2219, 0x2033: '\u2032\u2032',
          0x2034: '\u2032\u2032\u2032', 0x203E: 0x02C9, 0x2044: 0x002F,
          0x2057: '\u2032\u2032\u2032\u2032', 0x2126: 0x03A9, 0x2204: '\u2203\u0338',
          0x2206: 0x0394, 0x220C: '\u220B\u0338', 0x2244: '\u2243\u0338',
          0x2249: '\u2248\u0338', 0x2262: '\u2261\u0338', 0x226D: '\u224D\u0338',
          0x2274: '\u2272\u0338', 0x2275: '\u2273\u0338', 0x2278: '\u2276\u0338',
          0x2279: '\u2277\u0338', 0x2284: '\u2282\u0338', 0x2285: '\u2283\u0338',
          0x22E2: '\u2291\u0338', 0x22E3: '\u2292\u0338', 0x2329: 0x27E8, 0x232A: 0x27E9,
          0x25B5: 0x25B3, 0x25BF: 0x25BD, 0x2758: 0x2223, 0x2A2F: 0x00D7, 0x3008: 0x27E8,
          0x3009: 0x27E9, 0x1D715: 0x2202
        })
      ], {stringFonts: ['TEX-A']}],
      ['TEX-MI', [
        CHARS.At(0x00A3)
      ], {stringFonts: ['TEX-A']}],
      ['TEX-A', [
        CHARS.Range(0x2136, 0x2138),
        CHARS.Range(0x21AB, 0x21AE),
        CHARS.Range(0x21C2, 0x21C4),
        CHARS.Range(0x21C6, 0x21CB),
        CHARS.Range(0x21CD, 0x21CF),
        CHARS.Range(0x2251, 0x2253),
        CHARS.Range(0x2266, 0x2269),
        CHARS.Range(0x226E, 0x2273),
        CHARS.Range(0x227C, 0x2281),
        CHARS.Range(0x2288, 0x228B),
        CHARS.Range(0x229D, 0x22A1),
        CHARS.Range(0x22AC, 0x22AF),
        CHARS.Range(0x22B2, 0x22B5),
        CHARS.Range(0x22BA, 0x22BC),
        CHARS.Range(0x22C9, 0x22D4),
        CHARS.Range(0x22D6, 0x22DB),
        CHARS.Range(0x22DE, 0x22E1),
        CHARS.Range(0x22E6, 0x22ED),
        CHARS.Range(0x2A85, 0x2A8C),
        CHARS.Range(0x2AB5, 0x2ABA),
        CHARS.Range(0xE006, 0xE009),
        CHARS.Range(0xE00C, 0xE011),
        CHARS.Range(0xE016, 0xE01B),
        CHARS.At(
          0x00A5, 0x00AE, 0x00F0, 0x2035, 0x210F, 0x2127, 0x2132, 0x2141, 0x219A, 0x219B,
          0x219E, 0x21A0, 0x21A2, 0x21A3, 0x21B0, 0x21B1, 0x21B6, 0x21B7, 0x21BA, 0x21BB,
          0x21BE, 0x21BF, 0x21DA, 0x21DB, 0x21DD, 0x21E0, 0x21E2, 0x2201, 0x220D, 0x2214,
          0x2221, 0x2222, 0x2224, 0x2226, 0x2234, 0x2235, 0x223D, 0x2241, 0x2242, 0x224A,
          0x224E, 0x224F, 0x2256, 0x2257, 0x225C, 0x226C, 0x2276, 0x2277, 0x228F, 0x2290,
          0x229A, 0x229B, 0x22A9, 0x22AA, 0x22B8, 0x22C7, 0x24C8, 0x250C, 0x2510, 0x2514,
          0x2518, 0x2571, 0x2572, 0x25A0, 0x25A1, 0x25B2, 0x25B6, 0x25BC, 0x25C0, 0x25CA,
          0x2605, 0x2713, 0x2720, 0x29EB, 0x2A5E, 0x2A7D, 0x2A7E, 0x2A95, 0x2A96, 0x2AC5,
          0x2AC6, 0x2ACB, 0x2ACC
        ),
        CHARS.Map({
          0x2036: '\u2035\u2035', 0x2037: '\u2035\u2035\u2035', 0x2102: 0x0043, 0x210D: 0x0048, 0x2115: 0x004E,
          0x2119: 0x0050, 0x211A: 0x0051, 0x211D: 0x0052, 0x2124: 0x005A, 0x2247: 0x2246,
          0x2305: 0x22BC, 0x2306: 0x2A5E, 0x231C: 0x250C, 0x231D: 0x2510, 0x231E: 0x2514,
          0x231F: 0x2518, 0x25AA: 0x25A0, 0x25B4: 0x25B2, 0x25B8: 0x25B6, 0x25BE: 0x25BC,
          0x25C2: 0x25C0, 0x25FB: 0x25A1, 0x25FC: 0x25A0, 0x1D538: 0x0041, 0x1D539: 0x0042,
          0x1D53B: 0x0044, 0x1D53C: 0x0045, 0x1D53D: 0x0046, 0x1D53E: 0x0047, 0x1D540: 0x0049,
          0x1D541: 0x004A, 0x1D542: 0x004B, 0x1D543: 0x004C, 0x1D544: 0x004D, 0x1D546: 0x004F,
          0x1D54A: 0x0053, 0x1D54B: 0x0054, 0x1D54C: 0x0055, 0x1D54D: 0x0056, 0x1D54E: 0x0057,
          0x1D54F: 0x0058, 0x1D550: 0x0059, 0x1D718: 0xE009, 0x1D752: 0xE009
       })
      ], {stringFonts: ['TEX-A']}],
      ['TEX-V', [
        CHARS.Map({0x20D7: 0x2192})
      ], {stringFonts: ['TEX-A']}],
      ['TEX-SC', [
        CHARS.Map({
          0x210B: 0x0048, 0x2110: 0x0049, 0x2112: 0x004C, 0x211B: 0x0052, 0x212C: 0x0042,
          0x2130: 0x0045, 0x2131: 0x0046, 0x2133: 0x004D, 0x1D49C: 0x0041, 0x1D49E: 0x0043,
          0x1D49F: 0x0044, 0x1D4A2: 0x0047, 0x1D4A5: 0x004A, 0x1D4A6: 0x004B, 0x1D4A9: 0x004E,
          0x1D4AA: 0x004F, 0x1D4AB: 0x0050, 0x1D4AC: 0x0051, 0x1D4AE: 0x0053, 0x1D4AF: 0x0054,
          0x1D4B0: 0x0055, 0x1D4B1: 0x0056, 0x1D4B2: 0x0057, 0x1D4B3: 0x0058, 0x1D4B4: 0x0059,
          0x1D4B5: 0x005A
       })
      ], {stringFonts: ['TEX-A']}],
      ['TEX-FR', [
        CHARS.Map({
          0x210C: 0x0048, 0x2111: 0x0049, 0x211C: 0x0052, 0x2128: 0x005A, 0x212D: 0x0043,
          0x1D504: 0x0041, 0x1D505: 0x0042, 0x1D507: 0x0044, 0x1D508: 0x0045, 0x1D509: 0x0046,
          0x1D50A: 0x0047, 0x1D50D: 0x004A, 0x1D50E: 0x004B, 0x1D50F: 0x004C, 0x1D510: 0x004D,
          0x1D511: 0x004E, 0x1D512: 0x004F, 0x1D513: 0x0050, 0x1D514: 0x0051, 0x1D516: 0x0053,
          0x1D517: 0x0054, 0x1D518: 0x0055, 0x1D519: 0x0056, 0x1D51A: 0x0057, 0x1D51B: 0x0058,
          0x1D51C: 0x0059, 0x1D51E: 0x0061, 0x1D51F: 0x0062, 0x1D520: 0x0063, 0x1D521: 0x0064,
          0x1D522: 0x0065, 0x1D523: 0x0066, 0x1D524: 0x0067, 0x1D525: 0x0068, 0x1D526: 0x0069,
          0x1D527: 0x006A, 0x1D528: 0x006B, 0x1D529: 0x006C, 0x1D52A: 0x006D, 0x1D52B: 0x006E,
          0x1D52C: 0x006F, 0x1D52D: 0x0070, 0x1D52E: 0x0071, 0x1D52F: 0x0072, 0x1D530: 0x0073,
          0x1D531: 0x0074, 0x1D532: 0x0075, 0x1D533: 0x0076, 0x1D534: 0x0077, 0x1D535: 0x0078,
          0x1D536: 0x0079, 0x1D537: 0x007A
       })
      ], {stringFonts: ['TEX-A']}],
      ['TEX-I', [
        CHARS.Map({
          0x210E: 0x0068, 0x29F8: 0x002F, 0x1D434: 0x0041, 0x1D435: 0x0042, 0x1D436: 0x0043,
          0x1D437: 0x0044, 0x1D438: 0x0045, 0x1D439: 0x0046, 0x1D43A: 0x0047, 0x1D43B: 0x0048,
          0x1D43C: 0x0049, 0x1D43D: 0x004A, 0x1D43E: 0x004B, 0x1D43F: 0x004C, 0x1D440: 0x004D,
          0x1D441: 0x004E, 0x1D442: 0x004F, 0x1D443: 0x0050, 0x1D444: 0x0051, 0x1D445: 0x0052,
          0x1D446: 0x0053, 0x1D447: 0x0054, 0x1D448: 0x0055, 0x1D449: 0x0056, 0x1D44A: 0x0057,
          0x1D44B: 0x0058, 0x1D44C: 0x0059, 0x1D44D: 0x005A, 0x1D44E: 0x0061, 0x1D44F: 0x0062,
          0x1D450: 0x0063, 0x1D451: 0x0064, 0x1D452: 0x0065, 0x1D453: 0x0066, 0x1D454: 0x0067,
          0x1D456: 0x0069, 0x1D457: 0x006A, 0x1D458: 0x006B, 0x1D459: 0x006C, 0x1D45A: 0x006D,
          0x1D45B: 0x006E, 0x1D45C: 0x006F, 0x1D45D: 0x0070, 0x1D45E: 0x0071, 0x1D45F: 0x0072,
          0x1D460: 0x0073, 0x1D461: 0x0074, 0x1D462: 0x0075, 0x1D463: 0x0076, 0x1D464: 0x0077,
          0x1D465: 0x0078, 0x1D466: 0x0079, 0x1D467: 0x007A, 0x1D6E2: 0x0041, 0x1D6E3: 0x0042,
          0x1D6E4: 0x0393, 0x1D6E5: 0x0394, 0x1D6E6: 0x0045, 0x1D6E7: 0x005A, 0x1D6E8: 0x0048,
          0x1D6E9: 0x0398, 0x1D6EA: 0x0049, 0x1D6EB: 0x004B, 0x1D6EC: 0x039B, 0x1D6ED: 0x004D,
          0x1D6EE: 0x004E, 0x1D6EF: 0x039E, 0x1D6F0: 0x004F, 0x1D6F1: 0x03A0, 0x1D6F2: 0x0050,
          0x1D6F4: 0x03A3, 0x1D6F5: 0x0054, 0x1D6F6: 0x03A5, 0x1D6F7: 0x03A6, 0x1D6F8: 0x0058,
          0x1D6F9: 0x03A8, 0x1D6FA: 0x03A9, 0x1D6FC: 0x03B1, 0x1D6FD: 0x03B2, 0x1D6FE: 0x03B3,
          0x1D6FF: 0x03B4, 0x1D700: 0x03B5, 0x1D701: 0x03B6, 0x1D702: 0x03B7, 0x1D703: 0x03B8,
          0x1D704: 0x03B9, 0x1D705: 0x03BA, 0x1D706: 0x03BB, 0x1D707: 0x03BC, 0x1D708: 0x03BD,
          0x1D709: 0x03BE, 0x1D70A: 0x03BF, 0x1D70B: 0x03C0, 0x1D70C: 0x03C1, 0x1D70D: 0x03C2,
          0x1D70E: 0x03C3, 0x1D70F: 0x03C4, 0x1D710: 0x03C5, 0x1D711: 0x03C6, 0x1D712: 0x03C7,
          0x1D713: 0x03C8, 0x1D714: 0x03C9, 0x1D716: 0x03F5, 0x1D717: 0x03D1, 0x1D719: 0x03D5,
          0x1D71A: 0x03F1, 0x1D71B: 0x03D6
       })
      ], {stringFonts: ['TEX-A']}],
      ['TEX-S1', [
        CHARS.Range(0x220F, 0x2211),
        CHARS.Range(0x222C, 0x222E),
        CHARS.Range(0x22C0, 0x22C3),
        CHARS.Range(0x2A00, 0x2A02),
        CHARS.At(0x23D0, 0x2A04, 0x2A06, 0x2A0C)
      ], {stringFonts: ['TEX-A']}],
      ['TEX-B', [
        CHARS.Map({
          0x1D400: 0x0041, 0x1D401: 0x0042, 0x1D402: 0x0043, 0x1D403: 0x0044, 0x1D404: 0x0045,
          0x1D405: 0x0046, 0x1D406: 0x0047, 0x1D407: 0x0048, 0x1D408: 0x0049, 0x1D409: 0x004A,
          0x1D40A: 0x004B, 0x1D40B: 0x004C, 0x1D40C: 0x004D, 0x1D40D: 0x004E, 0x1D40E: 0x004F,
          0x1D40F: 0x0050, 0x1D410: 0x0051, 0x1D411: 0x0052, 0x1D412: 0x0053, 0x1D413: 0x0054,
          0x1D414: 0x0055, 0x1D415: 0x0056, 0x1D416: 0x0057, 0x1D417: 0x0058, 0x1D418: 0x0059,
          0x1D419: 0x005A, 0x1D41A: 0x0061, 0x1D41B: 0x0062, 0x1D41C: 0x0063, 0x1D41D: 0x0064,
          0x1D41E: 0x0065, 0x1D41F: 0x0066, 0x1D420: 0x0067, 0x1D421: 0x0068, 0x1D422: 0x0069,
          0x1D423: 0x006A, 0x1D424: 0x006B, 0x1D425: 0x006C, 0x1D426: 0x006D, 0x1D427: 0x006E,
          0x1D428: 0x006F, 0x1D429: 0x0070, 0x1D42A: 0x0071, 0x1D42B: 0x0072, 0x1D42C: 0x0073,
          0x1D42D: 0x0074, 0x1D42E: 0x0075, 0x1D42F: 0x0076, 0x1D430: 0x0077, 0x1D431: 0x0078,
          0x1D432: 0x0079, 0x1D433: 0x007A, 0x1D6A8: 0x0041, 0x1D6A9: 0x0042, 0x1D6AA: 0x0393,
          0x1D6AB: 0x0394, 0x1D6AC: 0x0045, 0x1D6AD: 0x005A, 0x1D6AE: 0x0048, 0x1D6AF: 0x0398,
          0x1D6B0: 0x0049, 0x1D6B1: 0x004B, 0x1D6B2: 0x039B, 0x1D6B3: 0x004D, 0x1D6B4: 0x004E,
          0x1D6B5: 0x039E, 0x1D6B6: 0x004F, 0x1D6B7: 0x03A0, 0x1D6B8: 0x0050, 0x1D6BA: 0x03A3,
          0x1D6BB: 0x0054, 0x1D6BC: 0x03A5, 0x1D6BD: 0x03A6, 0x1D6BE: 0x0058, 0x1D6BF: 0x03A8,
          0x1D6C0: 0x03A9, 0x1D6C1: 0x2207, 0x1D74F: 0x2202, 0x1D7CE: 0x0030, 0x1D7CF: 0x0031,
          0x1D7D0: 0x0032, 0x1D7D1: 0x0033, 0x1D7D2: 0x0034, 0x1D7D3: 0x0035, 0x1D7D4: 0x0036,
          0x1D7D5: 0x0037, 0x1D7D6: 0x0038, 0x1D7D7: 0x0039
       })
      ], {stringFonts: ['TEX-A']}],
      ['TEX-BI', [
        CHARS.Map({
          0x1D468: 0x0041, 0x1D469: 0x0042, 0x1D46A: 0x0043, 0x1D46B: 0x0044, 0x1D46C: 0x0045,
          0x1D46D: 0x0046, 0x1D46E: 0x0047, 0x1D46F: 0x0048, 0x1D470: 0x0049, 0x1D471: 0x004A,
          0x1D472: 0x004B, 0x1D473: 0x004C, 0x1D474: 0x004D, 0x1D475: 0x004E, 0x1D476: 0x004F,
          0x1D477: 0x0050, 0x1D478: 0x0051, 0x1D479: 0x0052, 0x1D47A: 0x0053, 0x1D47B: 0x0054,
          0x1D47C: 0x0055, 0x1D47D: 0x0056, 0x1D47E: 0x0057, 0x1D47F: 0x0058, 0x1D480: 0x0059,
          0x1D481: 0x005A, 0x1D482: 0x0061, 0x1D483: 0x0062, 0x1D484: 0x0063, 0x1D485: 0x0064,
          0x1D486: 0x0065, 0x1D487: 0x0066, 0x1D488: 0x0067, 0x1D489: 0x0068, 0x1D48A: 0x0069,
          0x1D48B: 0x006A, 0x1D48C: 0x006B, 0x1D48D: 0x006C, 0x1D48E: 0x006D, 0x1D48F: 0x006E,
          0x1D490: 0x006F, 0x1D491: 0x0070, 0x1D492: 0x0071, 0x1D493: 0x0072, 0x1D494: 0x0073,
          0x1D495: 0x0074, 0x1D496: 0x0075, 0x1D497: 0x0076, 0x1D498: 0x0077, 0x1D499: 0x0078,
          0x1D49A: 0x0079, 0x1D49B: 0x007A, 0x1D71C: 0x0041, 0x1D71D: 0x0042, 0x1D71E: 0x0393,
          0x1D71F: 0x0394, 0x1D720: 0x0045, 0x1D721: 0x005A, 0x1D722: 0x0048, 0x1D723: 0x0398,
          0x1D724: 0x0049, 0x1D725: 0x004B, 0x1D726: 0x039B, 0x1D727: 0x004D, 0x1D728: 0x004E,
          0x1D729: 0x039E, 0x1D72A: 0x004F, 0x1D72B: 0x03A0, 0x1D72C: 0x0050, 0x1D72E: 0x03A3,
          0x1D72F: 0x0054, 0x1D730: 0x03A5, 0x1D731: 0x03A6, 0x1D732: 0x0058, 0x1D733: 0x03A8,
          0x1D734: 0x03A9, 0x1D736: 0x03B1, 0x1D737: 0x03B2, 0x1D738: 0x03B3, 0x1D739: 0x03B4,
          0x1D73A: 0x03B5, 0x1D73B: 0x03B6, 0x1D73C: 0x03B7, 0x1D73D: 0x03B8, 0x1D73E: 0x03B9,
          0x1D73F: 0x03BA, 0x1D740: 0x03BB, 0x1D741: 0x03BC, 0x1D742: 0x03BD, 0x1D743: 0x03BE,
          0x1D744: 0x03BF, 0x1D745: 0x03C0, 0x1D746: 0x03C1, 0x1D747: 0x03C2, 0x1D748: 0x03C3,
          0x1D749: 0x03C4, 0x1D74A: 0x03C5, 0x1D74B: 0x03C6, 0x1D74C: 0x03C7, 0x1D74D: 0x03C8,
          0x1D74E: 0x03C9, 0x1D750: 0x03F5, 0x1D751: 0x03D1, 0x1D753: 0x03D5, 0x1D754: 0x03F1,
          0x1D755: 0x03D6
       })
      ], {stringFonts: ['TEX-A']}],
      ['TEX-FRB', [
        CHARS.Map({
          0x1D56C: 0x0041, 0x1D56D: 0x0042, 0x1D56E: 0x0043, 0x1D56F: 0x0044, 0x1D570: 0x0045,
          0x1D571: 0x0046, 0x1D572: 0x0047, 0x1D573: 0x0048, 0x1D574: 0x0049, 0x1D575: 0x004A,
          0x1D576: 0x004B, 0x1D577: 0x004C, 0x1D578: 0x004D, 0x1D579: 0x004E, 0x1D57A: 0x004F,
          0x1D57B: 0x0050, 0x1D57C: 0x0051, 0x1D57D: 0x0052, 0x1D57E: 0x0053, 0x1D57F: 0x0054,
          0x1D580: 0x0055, 0x1D581: 0x0056, 0x1D582: 0x0057, 0x1D583: 0x0058, 0x1D584: 0x0059,
          0x1D585: 0x005A, 0x1D586: 0x0061, 0x1D587: 0x0062, 0x1D588: 0x0063, 0x1D589: 0x0064,
          0x1D58A: 0x0065, 0x1D58B: 0x0066, 0x1D58C: 0x0067, 0x1D58D: 0x0068, 0x1D58E: 0x0069,
          0x1D58F: 0x006A, 0x1D590: 0x006B, 0x1D591: 0x006C, 0x1D592: 0x006D, 0x1D593: 0x006E,
          0x1D594: 0x006F, 0x1D595: 0x0070, 0x1D596: 0x0071, 0x1D597: 0x0072, 0x1D598: 0x0073,
          0x1D599: 0x0074, 0x1D59A: 0x0075, 0x1D59B: 0x0076, 0x1D59C: 0x0077, 0x1D59D: 0x0078,
          0x1D59E: 0x0079, 0x1D59F: 0x007A
       })
      ], {stringFonts: ['TEX-A']}],
      ['TEX-SS', [
        CHARS.Map({
          0x1D5A0: 0x0041, 0x1D5A1: 0x0042, 0x1D5A2: 0x0043, 0x1D5A3: 0x0044, 0x1D5A4: 0x0045,
          0x1D5A5: 0x0046, 0x1D5A6: 0x0047, 0x1D5A7: 0x0048, 0x1D5A8: 0x0049, 0x1D5A9: 0x004A,
          0x1D5AA: 0x004B, 0x1D5AB: 0x004C, 0x1D5AC: 0x004D, 0x1D5AD: 0x004E, 0x1D5AE: 0x004F,
          0x1D5AF: 0x0050, 0x1D5B0: 0x0051, 0x1D5B1: 0x0052, 0x1D5B2: 0x0053, 0x1D5B3: 0x0054,
          0x1D5B4: 0x0055, 0x1D5B5: 0x0056, 0x1D5B6: 0x0057, 0x1D5B7: 0x0058, 0x1D5B8: 0x0059,
          0x1D5B9: 0x005A, 0x1D5BA: 0x0061, 0x1D5BB: 0x0062, 0x1D5BC: 0x0063, 0x1D5BD: 0x0064,
          0x1D5BE: 0x0065, 0x1D5BF: 0x0066, 0x1D5C0: 0x0067, 0x1D5C1: 0x0068, 0x1D5C2: 0x0069,
          0x1D5C3: 0x006A, 0x1D5C4: 0x006B, 0x1D5C5: 0x006C, 0x1D5C6: 0x006D, 0x1D5C7: 0x006E,
          0x1D5C8: 0x006F, 0x1D5C9: 0x0070, 0x1D5CA: 0x0071, 0x1D5CB: 0x0072, 0x1D5CC: 0x0073,
          0x1D5CD: 0x0074, 0x1D5CE: 0x0075, 0x1D5CF: 0x0076, 0x1D5D0: 0x0077, 0x1D5D1: 0x0078,
          0x1D5D2: 0x0079, 0x1D5D3: 0x007A, 0x1D7E2: 0x0030, 0x1D7E3: 0x0031, 0x1D7E4: 0x0032,
          0x1D7E5: 0x0033, 0x1D7E6: 0x0034, 0x1D7E7: 0x0035, 0x1D7E8: 0x0036, 0x1D7E9: 0x0037,
          0x1D7EA: 0x0038, 0x1D7EB: 0x0039
       })
      ], {stringFonts: ['TEX-A']}],
      ['TEX-SSB', [
        CHARS.Map({
          0x1D5D4: 0x0041, 0x1D5D5: 0x0042, 0x1D5D6: 0x0043, 0x1D5D7: 0x0044, 0x1D5D8: 0x0045,
          0x1D5D9: 0x0046, 0x1D5DA: 0x0047, 0x1D5DB: 0x0048, 0x1D5DC: 0x0049, 0x1D5DD: 0x004A,
          0x1D5DE: 0x004B, 0x1D5DF: 0x004C, 0x1D5E0: 0x004D, 0x1D5E1: 0x004E, 0x1D5E2: 0x004F,
          0x1D5E3: 0x0050, 0x1D5E4: 0x0051, 0x1D5E5: 0x0052, 0x1D5E6: 0x0053, 0x1D5E7: 0x0054,
          0x1D5E8: 0x0055, 0x1D5E9: 0x0056, 0x1D5EA: 0x0057, 0x1D5EB: 0x0058, 0x1D5EC: 0x0059,
          0x1D5ED: 0x005A, 0x1D5EE: 0x0061, 0x1D5EF: 0x0062, 0x1D5F0: 0x0063, 0x1D5F1: 0x0064,
          0x1D5F2: 0x0065, 0x1D5F3: 0x0066, 0x1D5F4: 0x0067, 0x1D5F5: 0x0068, 0x1D5F6: 0x0069,
          0x1D5F7: 0x006A, 0x1D5F8: 0x006B, 0x1D5F9: 0x006C, 0x1D5FA: 0x006D, 0x1D5FB: 0x006E,
          0x1D5FC: 0x006F, 0x1D5FD: 0x0070, 0x1D5FE: 0x0071, 0x1D5FF: 0x0072, 0x1D600: 0x0073,
          0x1D601: 0x0074, 0x1D602: 0x0075, 0x1D603: 0x0076, 0x1D604: 0x0077, 0x1D605: 0x0078,
          0x1D606: 0x0079, 0x1D607: 0x007A, 0x1D756: 0x0041, 0x1D757: 0x0042, 0x1D758: 0x0393,
          0x1D759: 0x0394, 0x1D75A: 0x0045, 0x1D75B: 0x005A, 0x1D75C: 0x0048, 0x1D75D: 0x0398,
          0x1D75E: 0x0049, 0x1D75F: 0x004B, 0x1D760: 0x039B, 0x1D761: 0x004D, 0x1D762: 0x004E,
          0x1D763: 0x039E, 0x1D764: 0x004F, 0x1D765: 0x03A0, 0x1D766: 0x0050, 0x1D768: 0x03A3,
          0x1D769: 0x0054, 0x1D76A: 0x03A5, 0x1D76B: 0x03A6, 0x1D76C: 0x0058, 0x1D76D: 0x03A8,
          0x1D76E: 0x03A9, 0x1D7EC: 0x0030, 0x1D7ED: 0x0031, 0x1D7EE: 0x0032, 0x1D7EF: 0x0033,
          0x1D7F0: 0x0034, 0x1D7F1: 0x0035, 0x1D7F2: 0x0036, 0x1D7F3: 0x0037, 0x1D7F4: 0x0038,
          0x1D7F5: 0x0039
       })
      ], {stringFonts: ['TEX-A']}],
      ['TEX-SSI', [
        CHARS.Map({
          0x1D608: 0x0041, 0x1D609: 0x0042, 0x1D60A: 0x0043, 0x1D60B: 0x0044, 0x1D60C: 0x0045,
          0x1D60D: 0x0046, 0x1D60E: 0x0047, 0x1D60F: 0x0048, 0x1D610: 0x0049, 0x1D611: 0x004A,
          0x1D612: 0x004B, 0x1D613: 0x004C, 0x1D614: 0x004D, 0x1D615: 0x004E, 0x1D616: 0x004F,
          0x1D617: 0x0050, 0x1D618: 0x0051, 0x1D619: 0x0052, 0x1D61A: 0x0053, 0x1D61B: 0x0054,
          0x1D61C: 0x0055, 0x1D61D: 0x0056, 0x1D61E: 0x0057, 0x1D61F: 0x0058, 0x1D620: 0x0059,
          0x1D621: 0x005A, 0x1D622: 0x0061, 0x1D623: 0x0062, 0x1D624: 0x0063, 0x1D625: 0x0064,
          0x1D626: 0x0065, 0x1D627: 0x0066, 0x1D628: 0x0067, 0x1D629: 0x0068, 0x1D62A: 0x0069,
          0x1D62B: 0x006A, 0x1D62C: 0x006B, 0x1D62D: 0x006C, 0x1D62E: 0x006D, 0x1D62F: 0x006E,
          0x1D630: 0x006F, 0x1D631: 0x0070, 0x1D632: 0x0071, 0x1D633: 0x0072, 0x1D634: 0x0073,
          0x1D635: 0x0074, 0x1D636: 0x0075, 0x1D637: 0x0076, 0x1D638: 0x0077, 0x1D639: 0x0078,
          0x1D63A: 0x0079, 0x1D63B: 0x007A
       })
      ], {stringFonts: ['TEX-A']}],
      ['TEX-T', [
        CHARS.Map({
          0x1D670: 0x0041, 0x1D671: 0x0042, 0x1D672: 0x0043, 0x1D673: 0x0044, 0x1D674: 0x0045,
          0x1D675: 0x0046, 0x1D676: 0x0047, 0x1D677: 0x0048, 0x1D678: 0x0049, 0x1D679: 0x004A,
          0x1D67A: 0x004B, 0x1D67B: 0x004C, 0x1D67C: 0x004D, 0x1D67D: 0x004E, 0x1D67E: 0x004F,
          0x1D67F: 0x0050, 0x1D680: 0x0051, 0x1D681: 0x0052, 0x1D682: 0x0053, 0x1D683: 0x0054,
          0x1D684: 0x0055, 0x1D685: 0x0056, 0x1D686: 0x0057, 0x1D687: 0x0058, 0x1D688: 0x0059,
          0x1D689: 0x005A, 0x1D68A: 0x0061, 0x1D68B: 0x0062, 0x1D68C: 0x0063, 0x1D68D: 0x0064,
          0x1D68E: 0x0065, 0x1D68F: 0x0066, 0x1D690: 0x0067, 0x1D691: 0x0068, 0x1D692: 0x0069,
          0x1D693: 0x006A, 0x1D694: 0x006B, 0x1D695: 0x006C, 0x1D696: 0x006D, 0x1D697: 0x006E,
          0x1D698: 0x006F, 0x1D699: 0x0070, 0x1D69A: 0x0071, 0x1D69B: 0x0072, 0x1D69C: 0x0073,
          0x1D69D: 0x0074, 0x1D69E: 0x0075, 0x1D69F: 0x0076, 0x1D6A0: 0x0077, 0x1D6A1: 0x0078,
          0x1D6A2: 0x0079, 0x1D6A3: 0x007A, 0x1D7F6: 0x0030, 0x1D7F7: 0x0031, 0x1D7F8: 0x0032,
          0x1D7F9: 0x0033, 0x1D7FA: 0x0034, 0x1D7FB: 0x0035, 0x1D7FC: 0x0036, 0x1D7FD: 0x0037,
          0x1D7FE: 0x0038, 0x1D7FF: 0x0039
       })
      ], {stringFonts: ['TEX-A']}]
    ],
    'bold': [
      ['TEX-B', [
        CHARS.Range(0x0021, 0x002F),
        CHARS.Range(0x003A, 0x0040),
        CHARS.Range(0x005B, 0x0060),
        CHARS.Range(0x007B, 0x007E),
        CHARS.Range(0x00AF, 0x00B1),
        CHARS.Range(0x02C9, 0x02CB),
        CHARS.Range(0x02D8, 0x02DA),
        CHARS.Range(0x0300, 0x0304),
        CHARS.Range(0x0306, 0x0308),
        CHARS.Range(0x030A, 0x030C),
        CHARS.Range(0x2190, 0x2199),
        CHARS.Range(0x21D0, 0x21D5),
        CHARS.Range(0x2215, 0x221A),
        CHARS.Range(0x2227, 0x222B),
        CHARS.Range(0x2291, 0x2299),
        CHARS.Range(0x22A2, 0x22A5),
        CHARS.Range(0x22C4, 0x22C6),
        CHARS.Range(0x2308, 0x230B),
        CHARS.Range(0x2660, 0x2663),
        CHARS.Range(0x266D, 0x266F),
        CHARS.Range(0x27F5, 0x27FA),
        CHARS.At(
          0x00A8, 0x00AC, 0x00B4, 0x00D7, 0x00F7, 0x02C6, 0x02C7, 0x02DC, 0x0338, 0x2013,
          0x2014, 0x2018, 0x2019, 0x201C, 0x201D, 0x2020, 0x2021, 0x2026, 0x2032, 0x210F,
          0x2113, 0x2118, 0x2135, 0x21A6, 0x21A9, 0x21AA, 0x21BC, 0x21BD, 0x21C0, 0x21C1,
          0x21CC, 0x2200, 0x2203, 0x2205, 0x2208, 0x2209, 0x220B, 0x2212, 0x2213, 0x221D,
          0x221E, 0x2220, 0x2223, 0x2225, 0x223C, 0x2240, 0x2243, 0x2245, 0x2248, 0x224D,
          0x2250, 0x2260, 0x2261, 0x2264, 0x2265, 0x226A, 0x226B, 0x227A, 0x227B, 0x2282,
          0x2283, 0x2286, 0x2287, 0x228E, 0x22A8, 0x22C8, 0x22EE, 0x22EF, 0x22F1, 0x2322,
          0x2323, 0x25B3, 0x25B9, 0x25BD, 0x25C3, 0x25EF, 0x27E8, 0x27E9, 0x27FC, 0x2A3F,
          0x2AAF, 0x2AB0
        ),
        CHARS.Map({
          0x00B7: 0x22C5, 0x02B9: 0x2032, 0x2015: 0x2014, 0x2016: 0x2225, 0x2017: 0x005F,
          0x2022: 0x2219, 0x2033: '\u2032\u2032', 0x2034: '\u2032\u2032\u2032',
          0x203E: 0x02C9, 0x2044: 0x002F, 0x2057: '\u2032\u2032\u2032\u2032',
          0x219A: '\u2190\u0338', 0x219B: '\u2192\u0338', 0x21AE: '\u2194\u0338',
          0x21CD: '\u21D0\u0338', 0x21CE: '\u21D4\u0338', 0x21CF: '\u21D2\u0338',
          0x2204: '\u2203\u0338', 0x2206: 0x0394, 0x220C: '\u220B\u0338',
          0x2224: '\u2223\u0338', 0x2226: '\u2225\u0338', 0x2241: '\u223C\u0338',
          0x2244: '\u2243\u0338', 0x2247: '\u2245\u0338', 0x2249: '\u2248\u0338',
          0x2262: '\u2261\u0338', 0x226D: '\u224D\u0338', 0x226E: '<\u0338',
          0x226F: '>\u0338', 0x2270: '\u2264\u0338', 0x2271: '\u2265\u0338',
          0x2280: '\u227A\u0338', 0x2281: '\u227B\u0338', 0x2284: '\u2282\u0338',
          0x2285: '\u2283\u0338', 0x2288: '\u2286\u0338', 0x2289: '\u2287\u0338',
          0x22AC: '\u22A2\u0338', 0x22AD: '\u22A8\u0338', 0x22E2: '\u2291\u0338',
          0x22E3: '\u2292\u0338', 0x2329: 0x27E8, 0x232A: 0x27E9, 0x25B5: 0x25B3,
          0x25BF: 0x25BD, 0x2758: 0x2223, 0x2A2F: 0x00D7, 0x3008: 0x27E8, 0x3009: 0x27E9
       })
      ]],
      ['TEX-VB', [
        CHARS.Map({0x20D7: 0x2192})
      ]],
      ['TEX-BI', [
        CHARS.Map({0x29F8: 0x002F})
      ]]
    ],
    'italic': [
      ['TEX-MI', [
        CHARS.Range(0x0021, 0x0023),
        CHARS.Range(0x0025, 0x002E),
        CHARS.Range(0x0030, 0x003B),
        CHARS.Range(0x005D, 0x005F),
        CHARS.Range(0x0300, 0x0304),
        CHARS.Range(0x0306, 0x0308),
        CHARS.Range(0x030A, 0x030C),
        CHARS.At(
          0x003D, 0x003F, 0x0040, 0x005B, 0x007E, 0x0131, 0x0237,
          0x2013, 0x2014, 0x2018, 0x2019, 0x201C, 0x201D, 0x210F
        ),
        CHARS.Map({0x2015: 0x2014, 0x2017: 0x005F})
      ]],
      ['TEX-I', [
        CHARS.At(0x002F),
        CHARS.Map({0x2044: 0x002F, 0x2206: 0x0394, 0x29F8: 0x002F})
      ]],
      ['TEX-A', [
        CHARS.Map({0x03DD: 0xE008})
      ]]
    ],
    'bold-italic': [
      ['TEX-BI', [
        CHARS.At(0x002F),
        CHARS.Map({0x2044: 0x002F, 0x2206: 0x0394, 0x29F8: 0x002F})
      ]],
      ['TEX-B', [
        CHARS.At(0x0131, 0x0237)
      ]]
    ],
    'double-struck': [

    ],
    'fraktur': [
      ['TEX-FR', [
        CHARS.Range(0x0026, 0x003B),
        CHARS.Range(0xE300, 0xE307),
        CHARS.At(0x0021, 0x0022, 0x003D, 0x003F, 0x005B, 0x005D, 0x005E, 0x2018, 0x2019),
        CHARS.Map({0x2044: 0x002F})
      ]]
    ],
    'bold-fraktur': [
      ['TEX-FRB', [
        CHARS.Range(0x0026, 0x003B),
        CHARS.Range(0xE301, 0xE305),
        CHARS.At(
          0x0021, 0x0022, 0x003D, 0x003F, 0x005B, 0x005D,
          0x005E, 0x2018, 0x2019, 0xE308, 0xE309
        ),
        CHARS.Map({0x2044: 0x002F})
      ]]
    ],
    'script': [

    ],
    'bold-script': [

    ],
    'sans-serif': [
      ['TEX-SS', [
        CHARS.Range(0x0021, 0x002F),
        CHARS.Range(0x005D, 0x005F),
        CHARS.Range(0x0300, 0x0304),
        CHARS.Range(0x0306, 0x0308),
        CHARS.Range(0x030A, 0x030C),
        CHARS.At(
          0x003A, 0x003B, 0x003D, 0x003F, 0x0040, 0x005B, 0x007E, 0x0131, 0x0237,
          0x0393, 0x0394, 0x0398, 0x039B, 0x039E, 0x03A0, 0x03A3, 0x03A5, 0x03A6,
          0x03A8, 0x03A9, 0x2013, 0x2014, 0x2018, 0x2019, 0x201C, 0x201D
        ),
        CHARS.Map({
          0x0391: 0x0041, 0x0392: 0x0042, 0x0395: 0x0045, 0x0396: 0x005A, 0x0397: 0x0048,
          0x0399: 0x0049, 0x039A: 0x004B, 0x039C: 0x004D, 0x039D: 0x004E, 0x039F: 0x004F,
          0x03A1: 0x0050, 0x03A4: 0x0054, 0x03A7: 0x0058, 0x2015: 0x2014, 0x2017: 0x005F,
          0x2044: 0x002F, 0x2206: 0x0394
       })
      ]]
    ],
    'bold-sans-serif': [
      ['TEX-SSB', [
        CHARS.Range(0x0021, 0x002F),
        CHARS.Range(0x005D, 0x005F),
        CHARS.Range(0x0300, 0x0304),
        CHARS.Range(0x0306, 0x0308),
        CHARS.Range(0x030A, 0x030C),
        CHARS.At(
          0x003A, 0x003B, 0x003D, 0x003F, 0x0040, 0x005B, 0x007E, 0x0131,
          0x0237, 0x2013, 0x2014, 0x2018, 0x2019, 0x201C, 0x201D
        ),
        CHARS.Map({0x2015: 0x2014, 0x2017: 0x005F, 0x2044: 0x002F, 0x2206: 0x0394})
      ]]
    ],
    'sans-serif-italic': [
      ['TEX-SSI', [
        CHARS.Range(0x0021, 0x003B),
        CHARS.Range(0x005D, 0x005F),
        CHARS.Range(0x0300, 0x0304),
        CHARS.Range(0x0306, 0x0308),
        CHARS.Range(0x030A, 0x030C),
        CHARS.At(
          0x003D, 0x003F, 0x0040, 0x005B, 0x007E, 0x0131, 0x0237, 0x0393,
          0x0394, 0x0398, 0x039B, 0x039E, 0x03A0, 0x03A3, 0x03A5, 0x03A6,
          0x03A8, 0x03A9, 0x2013, 0x2014, 0x2018, 0x2019, 0x201C, 0x201D
        ),
        CHARS.Map({
          0x0391: 0x0041, 0x0392: 0x0042, 0x0395: 0x0045, 0x0396: 0x005A, 0x0397: 0x0048,
          0x0399: 0x0049, 0x039A: 0x004B, 0x039C: 0x004D, 0x039D: 0x004E, 0x039F: 0x004F,
          0x03A1: 0x0050, 0x03A4: 0x0054, 0x03A7: 0x0058, 0x2015: 0x2014, 0x2017: 0x005F,
          0x2044: 0x002F, 0x2206: 0x0394
       })
      ]]
    ],
    'sans-serif-bold-italic': [

    ],
    'monospace': [
      ['TEX-T', [
        CHARS.Range(0x0020, 0x002F),
        CHARS.Range(0x003A, 0x0040),
        CHARS.Range(0x005B, 0x0060),
        CHARS.Range(0x007B, 0x007F),
        CHARS.Range(0x0300, 0x0304),
        CHARS.At(
          0x00A0, 0x0131, 0x0237, 0x0306, 0x0308, 0x030A, 0x030C, 0x0393, 0x0394, 0x0398,
          0x039B, 0x039E, 0x03A0, 0x03A3, 0x03A5, 0x03A6, 0x03A8, 0x03A9, 0x2032
        ),
        CHARS.Map({
          0x02B9: 0x2032, 0x0391: 0x0041, 0x0392: 0x0042, 0x0395: 0x0045, 0x0396: 0x005A,
          0x0397: 0x0048, 0x0399: 0x0049, 0x039A: 0x004B, 0x039C: 0x004D, 0x039D: 0x004E,
          0x039F: 0x004F, 0x03A1: 0x0050, 0x03A4: 0x0054, 0x03A7: 0x0058, 0x2017: 0x005F,
          0x2033: '\u2032\u2032', 0x2034: '\u2032\u2032\u2032', 0x2044: 0x002F,
          0x2057: '\u2032\u2032\u2032\u2032', 0x2206: 0x0394
       })
      ]]
    ],
    '-smallop': [
      ['TEX-S1', [
        CHARS.Range(0x005B, 0x005D),
        CHARS.Range(0x220F, 0x2211),
        CHARS.Range(0x222B, 0x222E),
        CHARS.Range(0x22C0, 0x22C3),
        CHARS.Range(0x2308, 0x230B),
        CHARS.Range(0x2A00, 0x2A02),
        CHARS.At(
          0x0028, 0x0029, 0x002F, 0x007B, 0x007D, 0x02C6, 0x02DC, 0x0302,
          0x0303, 0x2016, 0x2190, 0x2191, 0x2192, 0x2193, 0x2194, 0x219E,
          0x21A0, 0x21A4, 0x21BC, 0x21BD, 0x21BE, 0x21C0, 0x21C1, 0x21D0,
          0x21D1, 0x21D2, 0x21D3, 0x21D4, 0x21DA, 0x21DB, 0x2212, 0x221A,
          0x2223, 0x2225, 0x2261, 0x23D0, 0x27E8, 0x27E9, 0x294C, 0x2A04,
          0x2A06, 0x23B4, 0x23B5, 0x2906, 0x2A0C
        ),
        CHARS.Map({
          0x2044: 0x002F, 0x2329: 0x27E8, 0x232A: 0x27E9, 0x2758: 0x2223,
          0x3008: 0x27E8, 0x3009: 0x27E9
       })
      ]]
    ],
    '-largeop': [
      ['TEX-S2', [
        CHARS.Range(0x005B, 0x005D),
        CHARS.Range(0x220F, 0x2211),
        CHARS.Range(0x222B, 0x222E),
        CHARS.Range(0x22C0, 0x22C3),
        CHARS.Range(0x2308, 0x230B),
        CHARS.Range(0x2A00, 0x2A02),
        CHARS.At(
          0x0028, 0x0029, 0x002F, 0x007B, 0x007D, 0x02C6, 0x02DC,
          0x0302, 0x0303, 0x221A, 0x27E8, 0x27E9, 0x2A04, 0x2A06
        ),
        CHARS.Map({
          0x2044: 0x002F, 0x2329: 0x27E8, 0x232A: 0x27E9,
          0x2A0C: '\u222C\u222C', 0x3008: 0x27E8, 0x3009: 0x27E9
       })
      ]],
      ['TEX-S1', [
        CHARS.At(0x2016, 0x2191, 0x2193, 0x21D1, 0x21D3, 0x2223, 0x2225, 0x23D0),
        CHARS.Map({0x2758: 0x2223})
      ]]
    ],
    '-tex-calligraphic': [
      ['TEX-C', [
        CHARS.Range(0x0041, 0x005A)
      ]]
    ],
    '-tex-bold-calligraphic': [
      ['TEX-CB', [
        CHARS.Range(0x0041, 0x005A)
      ]],
      ['TEX-B', [
        CHARS.At(0x0131, 0x0237)
      ]]
    ],
    '-tex-oldstyle': [
      ['TEX-C', [
        CHARS.Range(0x0030, 0x0039),
        CHARS.Range(0x0041, 0x005A)
      ]]
    ],
    '-tex-bold-oldstyle': [
      ['TEX-CB', [
        CHARS.Range(0x0030, 0x0039),
        CHARS.Range(0x0041, 0x005A)
      ]]
    ],
    '-tex-mathit': [
      ['TEX-MI', [
        CHARS.Range(0x0041, 0x005A),
        CHARS.Range(0x0061, 0x007A)
      ]]
    ],
    '-tex-variant': [
      ['TEX-A', [
        CHARS.At(
          0x02C6, 0x02DC, 0x0302, 0x0303, 0x210F, 0x2190, 0x2192, 0x21CC,
          0x2204, 0x2205, 0x2212, 0x2216, 0x221D, 0x2223, 0x2225, 0x223C,
          0x2248, 0x22A8, 0x22C5, 0x2322, 0x2323, 0x25B3, 0x25BD
        ),
        CHARS.Map({
          0x03F0: 0xE009, 0x2224: 0xE006, 0x2226: 0xE007, 0x2268: 0xE00C, 0x2269: 0xE00D,
          0x2270: 0xE011, 0x2271: 0xE00E, 0x2288: 0xE016, 0x2289: 0xE018, 0x228A: 0xE01A,
          0x228B: 0xE01B, 0x2A87: 0xE010, 0x2A88: 0xE00F, 0x2ACB: 0xE017, 0x2ACC: 0xE019
       })
      ]]
    ],
    '-size3': [
      ['TEX-S3', [
        CHARS.Range(0x005B, 0x005D),
        CHARS.Range(0x2308, 0x230B),
        CHARS.At(
          0x0028, 0x0029, 0x002F, 0x007B, 0x007D, 0x02C6,
          0x02DC, 0x0302, 0x0303, 0x221A, 0x27E8, 0x27E9
        ),
        CHARS.Map({
          0x2044: 0x002F, 0x2329: 0x27E8, 0x232A: 0x27E9, 0x3008: 0x27E8, 0x3009: 0x27E9
       })
      ]]
    ],
    '-size4': [
      ['TEX-S4', [
        CHARS.Range(0x005B, 0x005D),
        CHARS.Range(0x2308, 0x230B),
        CHARS.Range(0x239B, 0x23AD),
        CHARS.Range(0xE150, 0xE154),
        CHARS.At(
          0x0028, 0x0029, 0x002F, 0x007B, 0x007D, 0x02C6, 0x02DC, 0x0302,
          0x0303, 0x221A, 0x23B7, 0x27E8, 0x27E9, 0xE000, 0xE001
        ),
        CHARS.Map({
          0x2044: 0x002F, 0x2329: 0x27E8, 0x232A: 0x27E9, 0x3008: 0x27E8,
          0x3009: 0x27E9, 0xE155: '\uE153\uE152', 0xE156: '\uE151\uE150'
       })
      ]]
    ]
  }, {
    spaces: {
      normal: {
        0x2000: .5,    // en quad
        0x2001: 1,     // em quad
        0x2002: .5,    // en space
        0x2003: 1,     // em space
        0x2004: .333,  // three-per-em space
        0x2005: .25,   // four-per-em space
        0x2006: .167,  // six-per-em-space
        0x2009: .167,  // figurethin space
        0x200A: .1,    // hair space
        0x200B: 0,     // zero width space
        0x200C: 0,     // zero width non-joiner
        0x2060: 0,     // word joiner
        0x2061: 0,     // function application
        0x2062: 0,     // invisible times
        0x2063: 0,     // invisible separator
        0x2064: 0,     // invisible plus
      }
    },
    transferHD: [
      [0x2212, 0x002B]    // make minus the same height/depth as plus
    ],
    fixIC: [
      ['-largeop', .388, CHARS.At(0x2A0C)],  // adjust quadruple integral italic correction
    ],
    adjustHDW: {
      '-largeop': {0x2A0C: [0, 0, .388]},    // compensate for width change from ic correction
      'normal': {
        0x22EE: [.4, 0, 0],                  // add height to vdots
        0x22F1: [.6, 0, 0],                  // add height to ddots
      }
    },
    setSkew: {
      normal: {
        0x2A: 0.148,
        0x32: -0.01,
        0x34: 0.103,
        0x36: 0.068,
        0x37: -0.147,
        0x38: 0.011,
        0x42: -0.098,
        0x43: 0.146,
        0x44: -0.139,
        0x45: -0.025,
        0x46: -0.018,
        0x47: 0.115,
        0x4A: 0.06,
        0x4B: -0.011,
        0x4C: -0.119,
        0x50: -0.09,
        0x52: -0.134,
        0x53: 0.052,
        0x58: -0.014,
        0x5A: 0.011,
        0x60: -0.031,
        0x61: -0.036,
        0x62: -0.178,
        0x63: 0.027,
        0x64: 0.099,
        0x65: 0.014,
        0x66: 0.071,
        0x67: 0.082,
        0x68: -0.174,
        0x6B: -0.164,
        0x6C: -0.034,
        0x6D: -0.067,
        0x6E: -0.067,
        0x70: -0.076,
        0x71: 0.054,
        0x72: -0.015,
        0x73: 0.035,
        0x74: -0.034,
        0x75: -0.033,
        0x392: -0.068,
        0x393: -0.015,
        0x395: -0.022,
        0x396: 0.011,
        0x39A: -0.011,
        0x3A1: -0.058,
        0x3A3: -0.011,
        0x3A7: -0.014,
        0x210C: 0.062,
        0x210E: -0.075,
        0x2111: 0.06,
        0x2119: -0.072,
        0x211C: 0.016,
        0x211D: -0.072,
        0x2128: -0.137,
        0x212D: 0.19,
        0x1D401: -0.109,
        0x1D402: 0.165,
        0x1D403: -0.158,
        0x1D404: -0.028,
        0x1D405: -0.02,
        0x1D406: 0.127,
        0x1D409: 0.051,
        0x1D40A: -0.013,
        0x1D40B: -0.114,
        0x1D40F: -0.1,
        0x1D411: -0.15,
        0x1D412: 0.054,
        0x1D417: -0.017,
        0x1D419: 0.013,
        0x1D41A: -0.049,
        0x1D41B: -0.194,
        0x1D41C: 0.043,
        0x1D41D: 0.124,
        0x1D41E: 0.018,
        0x1D41F: 0.069,
        0x1D420: 0.07,
        0x1D421: -0.185,
        0x1D423: 0.013,
        0x1D424: -0.177,
        0x1D425: -0.024,
        0x1D426: -0.061,
        0x1D427: -0.063,
        0x1D429: -0.079,
        0x1D42A: 0.066,
        0x1D42B: -0.021,
        0x1D42C: 0.038,
        0x1D42D: -0.029,
        0x1D42E: -0.024,
        0x1D434: 0.175,
        0x1D435: 0.041,
        0x1D436: 0.205,
        0x1D437: 0.013,
        0x1D438: 0.095,
        0x1D439: 0.074,
        0x1D43A: 0.203,
        0x1D43B: 0.089,
        0x1D43C: 0.084,
        0x1D43D: 0.151,
        0x1D43E: 0.09,
        0x1D43F: 0.019,
        0x1D440: 0.085,
        0x1D441: 0.082,
        0x1D442: 0.114,
        0x1D443: 0.011,
        0x1D444: 0.1,
        0x1D445: 0.018,
        0x1D446: 0.168,
        0x1D447: 0.016,
        0x1D448: 0.022,
        0x1D449: -0.018,
        0x1D44B: 0.097,
        0x1D44C: -0.027,
        0x1D44D: 0.114,
        0x1D44E: 0.022,
        0x1D44F: -0.05,
        0x1D450: 0.101,
        0x1D451: 0.182,
        0x1D452: 0.067,
        0x1D453: 0.172,
        0x1D454: 0.077,
        0x1D456: 0.074,
        0x1D457: 0.153,
        0x1D458: -0.048,
        0x1D459: 0.035,
        0x1D45A: -0.035,
        0x1D45B: -0.035,
        0x1D45C: 0.072,
        0x1D45E: 0.121,
        0x1D45F: 0.021,
        0x1D460: 0.061,
        0x1D461: 0.044,
        0x1D462: 0.019,
        0x1D463: 0.051,
        0x1D464: 0.047,
        0x1D465: 0.043,
        0x1D466: 0.059,
        0x1D467: 0.102,
        0x1D468: 0.173,
        0x1D469: 0.044,
        0x1D46A: 0.221,
        0x1D46C: 0.099,
        0x1D46D: 0.072,
        0x1D46E: 0.214,
        0x1D46F: 0.091,
        0x1D470: 0.086,
        0x1D471: 0.153,
        0x1D472: 0.095,
        0x1D473: 0.018,
        0x1D474: 0.086,
        0x1D475: 0.083,
        0x1D476: 0.11,
        0x1D477: 0.012,
        0x1D478: 0.093,
        0x1D479: 0.014,
        0x1D47A: 0.199,
        0x1D47B: 0.014,
        0x1D47C: 0.015,
        0x1D47D: -0.018,
        0x1D47F: 0.106,
        0x1D480: -0.028,
        0x1D481: 0.122,
        0x1D482: 0.019,
        0x1D483: -0.035,
        0x1D484: 0.108,
        0x1D485: 0.207,
        0x1D486: 0.063,
        0x1D487: 0.189,
        0x1D488: 0.067,
        0x1D489: -0.106,
        0x1D48A: 0.08,
        0x1D48B: 0.163,
        0x1D48C: -0.074,
        0x1D48D: 0.022,
        0x1D48E: -0.038,
        0x1D48F: -0.038,
        0x1D490: 0.074,
        0x1D492: 0.138,
        0x1D493: 0.018,
        0x1D494: 0.059,
        0x1D495: 0.046,
        0x1D497: 0.049,
        0x1D498: 0.044,
        0x1D499: 0.029,
        0x1D49A: 0.05,
        0x1D49B: 0.102,
        0x1D504: 0.085,
        0x1D505: -0.01,
        0x1D508: 0.193,
        0x1D509: -0.059,
        0x1D50A: 0.126,
        0x1D50D: -0.054,
        0x1D50E: 0.115,
        0x1D50F: 0.104,
        0x1D510: 0.042,
        0x1D511: 0.037,
        0x1D512: -0.074,
        0x1D513: 0.025,
        0x1D514: -0.076,
        0x1D517: 0.332,
        0x1D518: 0.053,
        0x1D519: 0.019,
        0x1D51A: 0.01,
        0x1D51B: 0.049,
        0x1D51C: -0.011,
        0x1D51E: 0.079,
        0x1D51F: -0.068,
        0x1D520: 0.074,
        0x1D521: -0.084,
        0x1D522: 0.043,
        0x1D523: 0.058,
        0x1D524: 0.087,
        0x1D525: -0.092,
        0x1D527: -0.01,
        0x1D528: -0.011,
        0x1D529: 0.056,
        0x1D52A: -0.046,
        0x1D52B: -0.037,
        0x1D52C: 0.014,
        0x1D52D: -0.122,
        0x1D52E: 0.088,
        0x1D531: 0.051,
        0x1D533: -0.121,
        0x1D534: -0.26,
        0x1D535: 0.01,
        0x1D536: -0.121,
        0x1D537: -0.01,
        0x1D539: -0.072,
        0x1D53B: -0.1,
        0x1D53C: 0.029,
        0x1D53D: 0.029,
        0x1D541: 0.151,
        0x1D542: 0.013,
        0x1D543: -0.139,
        0x1D54A: -0.015,
        0x1D56C: 0.082,
        0x1D56E: 0.218,
        0x1D56F: -0.033,
        0x1D570: 0.207,
        0x1D571: -0.078,
        0x1D572: 0.17,
        0x1D573: 0.071,
        0x1D574: 0.073,
        0x1D575: -0.059,
        0x1D576: 0.126,
        0x1D577: 0.126,
        0x1D578: 0.038,
        0x1D579: 0.024,
        0x1D57A: -0.087,
        0x1D57B: 0.013,
        0x1D57C: -0.087,
        0x1D57D: 0.011,
        0x1D57F: 0.153,
        0x1D580: 0.104,
        0x1D582: 0.022,
        0x1D583: 0.064,
        0x1D585: -0.169,
        0x1D586: 0.087,
        0x1D588: 0.081,
        0x1D589: -0.105,
        0x1D58A: 0.048,
        0x1D58B: 0.072,
        0x1D58C: 0.111,
        0x1D58D: -0.097,
        0x1D590: -0.017,
        0x1D591: 0.125,
        0x1D592: -0.056,
        0x1D593: -0.071,
        0x1D594: 0.029,
        0x1D595: -0.124,
        0x1D596: 0.112,
        0x1D597: 0.013,
        0x1D599: 0.085,
        0x1D59A: 0.011,
        0x1D59B: -0.142,
        0x1D59C: -0.296,
        0x1D59D: 0.026,
        0x1D59E: -0.127,
        0x1D5A1: -0.077,
        0x1D5A2: 0.091,
        0x1D5A3: -0.109,
        0x1D5A4: 0.018,
        0x1D5A5: 0.025,
        0x1D5A6: 0.073,
        0x1D5A9: 0.109,
        0x1D5AA: 0.02,
        0x1D5AB: -0.132,
        0x1D5AF: -0.06,
        0x1D5B1: -0.066,
        0x1D5B2: 0.015,
        0x1D5B7: -0.015,
        0x1D5BA: -0.013,
        0x1D5BB: -0.139,
        0x1D5BC: 0.042,
        0x1D5BD: 0.139,
        0x1D5BE: 0.016,
        0x1D5BF: 0.096,
        0x1D5C0: 0.074,
        0x1D5C1: -0.14,
        0x1D5C4: -0.124,
        0x1D5C6: -0.038,
        0x1D5C7: -0.038,
        0x1D5C9: -0.03,
        0x1D5CA: 0.041,
        0x1D5CB: 0.034,
        0x1D5CC: 0.022,
        0x1D5CD: -0.04,
        0x1D5D5: -0.07,
        0x1D5D6: 0.082,
        0x1D5D7: -0.096,
        0x1D5D8: 0.015,
        0x1D5D9: 0.022,
        0x1D5DA: 0.061,
        0x1D5DD: 0.097,
        0x1D5DE: 0.016,
        0x1D5DF: -0.126,
        0x1D5E3: -0.064,
        0x1D5E5: -0.056,
        0x1D5EB: -0.015,
        0x1D5EF: -0.152,
        0x1D5F0: 0.041,
        0x1D5F1: 0.152,
        0x1D5F2: 0.011,
        0x1D5F3: 0.087,
        0x1D5F4: 0.065,
        0x1D5F5: -0.153,
        0x1D5F8: -0.138,
        0x1D5FA: -0.028,
        0x1D5FB: -0.028,
        0x1D5FD: -0.043,
        0x1D5FE: 0.061,
        0x1D5FF: 0.03,
        0x1D600: 0.015,
        0x1D601: -0.047,
        0x1D608: 0.147,
        0x1D609: 0.047,
        0x1D60A: 0.18,
        0x1D60B: 0.021,
        0x1D60C: 0.098,
        0x1D60D: 0.095,
        0x1D60E: 0.174,
        0x1D60F: 0.108,
        0x1D610: 0.108,
        0x1D611: 0.209,
        0x1D612: 0.1,
        0x1D613: 0.016,
        0x1D614: 0.112,
        0x1D615: 0.11,
        0x1D616: 0.131,
        0x1D617: 0.048,
        0x1D618: 0.131,
        0x1D619: 0.04,
        0x1D61A: 0.126,
        0x1D61B: 0.062,
        0x1D61C: 0.106,
        0x1D61D: 0.048,
        0x1D61E: 0.048,
        0x1D61F: 0.065,
        0x1D620: 0.04,
        0x1D621: 0.084,
        0x1D622: 0.084,
        0x1D624: 0.096,
        0x1D625: 0.237,
        0x1D626: 0.09,
        0x1D627: 0.133,
        0x1D628: 0.116,
        0x1D62A: 0.09,
        0x1D62B: 0.102,
        0x1D62C: -0.017,
        0x1D62D: 0.099,
        0x1D62E: 0.057,
        0x1D62F: 0.057,
        0x1D630: 0.079,
        0x1D631: 0.05,
        0x1D632: 0.126,
        0x1D633: 0.069,
        0x1D634: 0.08,
        0x1D635: 0.043,
        0x1D636: 0.084,
        0x1D637: 0.034,
        0x1D638: 0.034,
        0x1D639: 0.032,
        0x1D63A: 0.034,
        0x1D63B: 0.052,
        0x1D671: -0.073,
        0x1D672: 0.1,
        0x1D673: -0.098,
        0x1D676: 0.072,
        0x1D679: 0.085,
        0x1D67B: -0.11,
        0x1D67F: -0.07,
        0x1D681: -0.097,
        0x1D682: 0.046,
        0x1D68A: -0.048,
        0x1D68B: -0.172,
        0x1D68C: 0.043,
        0x1D68D: 0.088,
        0x1D68F: 0.077,
        0x1D690: 0.07,
        0x1D691: -0.172,
        0x1D693: 0.057,
        0x1D694: -0.169,
        0x1D695: -0.085,
        0x1D696: -0.052,
        0x1D697: -0.071,
        0x1D699: -0.074,
        0x1D69A: 0.044,
        0x1D69B: -0.018,
        0x1D69C: 0.04,
        0x1D69D: -0.074,
        0x1D69E: -0.043,
        0x1D6A9: -0.075,
        0x1D6AA: -0.019,
        0x1D6AC: -0.027,
        0x1D6AD: 0.013,
        0x1D6B1: -0.013,
        0x1D6B8: -0.063,
        0x1D6BA: -0.015,
        0x1D6BE: -0.017,
        0x1D6E2: 0.177,
        0x1D6E3: 0.077,
        0x1D6E4: 0.074,
        0x1D6E5: 0.17,
        0x1D6E6: 0.094,
        0x1D6E7: 0.11,
        0x1D6E8: 0.089,
        0x1D6E9: 0.117,
        0x1D6EA: 0.084,
        0x1D6EB: 0.09,
        0x1D6EC: 0.17,
        0x1D6ED: 0.085,
        0x1D6EE: 0.082,
        0x1D6EF: 0.097,
        0x1D6F0: 0.117,
        0x1D6F1: 0.089,
        0x1D6F2: 0.049,
        0x1D6F4: 0.104,
        0x1D6F5: 0.012,
        0x1D6F7: 0.082,
        0x1D6F8: 0.097,
        0x1D6F9: 0.025,
        0x1D6FA: 0.137,
        0x1D6FC: 0.072,
        0x1D6FD: 0.148,
        0x1D6FE: -0.019,
        0x1D6FF: 0.107,
        0x1D700: 0.051,
        0x1D701: 0.067,
        0x1D702: 0.024,
        0x1D703: 0.075,
        0x1D705: 0.043,
        0x1D706: -0.053,
        0x1D707: 0.048,
        0x1D708: 0.028,
        0x1D709: 0.06,
        0x1D70B: 0.043,
        0x1D70C: 0.096,
        0x1D70D: -0.034,
        0x1D710: 0.036,
        0x1D711: 0.028,
        0x1D712: 0.018,
        0x1D713: 0.143,
        0x1D714: 0.034,
        0x1D715: 0.069,
        0x1D716: 0.066,
        0x1D717: 0.116,
        0x1D718: 0.053,
        0x1D719: 0.125,
        0x1D71A: 0.102,
        0x1D71B: 0.039,
        0x1D71C: 0.174,
        0x1D71D: 0.069,
        0x1D71E: 0.071,
        0x1D71F: 0.168,
        0x1D720: 0.098,
        0x1D721: 0.117,
        0x1D722: 0.09,
        0x1D723: 0.108,
        0x1D724: 0.085,
        0x1D725: 0.093,
        0x1D726: 0.167,
        0x1D727: 0.085,
        0x1D728: 0.082,
        0x1D729: 0.104,
        0x1D72A: 0.111,
        0x1D72B: 0.09,
        0x1D72C: 0.039,
        0x1D72E: 0.11,
        0x1D72F: 0.01,
        0x1D731: 0.08,
        0x1D732: 0.106,
        0x1D733: 0.029,
        0x1D734: 0.135,
        0x1D736: 0.059,
        0x1D737: 0.153,
        0x1D738: -0.02,
        0x1D739: 0.115,
        0x1D73A: 0.058,
        0x1D73B: 0.083,
        0x1D73C: 0.019,
        0x1D73D: 0.062,
        0x1D73F: 0.025,
        0x1D740: -0.072,
        0x1D741: 0.042,
        0x1D742: 0.028,
        0x1D743: 0.061,
        0x1D745: 0.046,
        0x1D746: 0.1,
        0x1D747: -0.029,
        0x1D74A: 0.037,
        0x1D74B: 0.033,
        0x1D74C: 0.011,
        0x1D74D: 0.151,
        0x1D74E: 0.039,
        0x1D74F: 0.079,
        0x1D750: 0.074,
        0x1D751: 0.119,
        0x1D752: 0.053,
        0x1D753: 0.126,
        0x1D754: 0.094,
        0x1D755: 0.043,
        0x1D757: -0.04,
        0x1D758: 0.022,
        0x1D75A: 0.015,
        0x1D75F: 0.012,
        0x1D766: -0.034,
        0x1D76C: -0.015,
        0x1D7D0: -0.011,
        0x1D7D2: 0.127,
        0x1D7D4: 0.048,
        0x1D7D5: -0.164,
        0x1D7D6: 0.011,
        0x1D7E3: 0.01,
        0x1D7E6: 0.073,
        0x1D7E8: 0.084,
        0x1D7EE: -0.016,
        0x1D7F0: 0.068,
        0x1D7F2: 0.056,
        0x1D7F5: -0.016,
        0x1D7F7: 0.015,
        0x1D7F8: -0.011,
        0x1D7F9: -0.015,
        0x1D7FA: 0.06,
        0x1D7FC: 0.054,
        0x1D7FD: -0.184
      },
      italic: {
        0x237: 0.083
      },
      'bold-italic': {
        0x131: -0.012,
        0x237: 0.063
      },
      fraktur: {
        0x2A: 0.148,
        0x32: -0.01,
        0x34: 0.103,
        0x36: 0.068,
        0x37: -0.147,
        0x38: 0.011
      },
      'sans-serif': {
        0x237: 0.013
      },
      'bold-sans-serif': {
        0x237: 0.015
      },
      'sans-serif-italic': {
        0x131: 0.083,
        0x237: 0.097
      },
      '-tex-calligraphic': {
        0x41: 0.274,
        0x42: 0.09,
        0x43: 0.135,
        0x44: 0.06,
        0x45: 0.143,
        0x46: 0.266,
        0x47: 0.164,
        0x48: 0.163,
        0x49: 0.159,
        0x4A: 0.219,
        0x4B: 0.173,
        0x4C: 0.249,
        0x4D: 0.128,
        0x4E: 0.121,
        0x4F: 0.166,
        0x50: 0.099,
        0x51: 0.124,
        0x52: 0.123,
        0x53: 0.139,
        0x54: 0.112,
        0x55: 0.06,
        0x56: 0.042,
        0x57: 0.035,
        0x58: 0.121,
        0x59: 0.083,
        0x5A: 0.033
      },
      '-tex-bold-calligraphic': {
        0x41: 0.283,
        0x42: 0.101,
        0x43: 0.15,
        0x44: 0.045,
        0x45: 0.151,
        0x46: 0.151,
        0x47: 0.177,
        0x48: 0.178,
        0x49: 0.199,
        0x4A: 0.26,
        0x4B: 0.196,
        0x4C: 0.259,
        0x4D: 0.115,
        0x4E: 0.139,
        0x4F: 0.183,
        0x50: 0.126,
        0x51: 0.138,
        0x52: 0.133,
        0x53: 0.141,
        0x54: 0.144,
        0x55: 0.07,
        0x56: 0.035,
        0x57: 0.057,
        0x58: 0.125,
        0x59: 0.079,
        0x5A: 0.133,
        0x131: -0.012,
        0x237: 0.063
      },
      '-tex-oldstyle': {
        0x42: -0.098,
        0x43: 0.146,
        0x44: -0.139,
        0x45: -0.025,
        0x46: -0.018,
        0x47: 0.115,
        0x4A: 0.06,
        0x4B: -0.011,
        0x4C: -0.119,
        0x50: -0.09,
        0x52: -0.134,
        0x53: 0.052,
        0x58: -0.014,
        0x5A: 0.011
      },
      '-tex-variant': {
        0x3F0: -0.015
      }
    }
  });

  /***********************************************************************************/

  const MathJaxTexDelimiters = Delimiters.define({
    font: 'TEX-N',
    variants: MathJaxTexVariants,
    sizeVariants: ['normal', '-smallop', '-largeop', '-size3', '-size4', '-tex-variant'],
    stretchVariants: ['-size4'],
    readMathTable: false,
    add: {
      0x0028: {dir: 'V', sizes: 5, parts: [0x239B, 0x239C, 0x239D]},
      0x0029: {dir: 'V', sizes: 5, parts: [0x239E, 0x239F, 0x23A0]},
      0x002F: {dir: 'V', sizes: 5},
      0x003D: {dir: 'H', sizes: 1, parts: [0, [0x003D, 'normal']]},
      0x005B: {dir: 'V', sizes: 5, parts: [0x23A1, 0x23A2, 0x23A3]},
      0x005C: {dir: 'V', sizes: 5},
      0x005D: {dir: 'V', sizes: 5, parts: [0x23A4, 0x23A5, 0x23A6]},
      0x007B: {dir: 'V', sizes: 5, parts: [0x23A7, 0x23AA, 0x23A9, 0x23A8]},
      0x007C: {dir: 'V', sizes: 1, parts: [0, [0x2223, '-smallop']]},
      0x007D: {dir: 'V', sizes: 5, parts: [0x23AB, 0x23AA, 0x23AD, 0x23AC]},
      0x00AF: {dir: 'H', sizes: 1, parts: [0, [0x00AF, 'normal']]},
      0x02C6: {dir: 'H', sizes: 5},
      0x02DC: {dir: 'H', sizes: 5},
      0x2013: {dir: 'H', sizes: 1, parts: [0, [0x2013, 'normal']]},
      0x2016: {dir: 'V', sizes: 1, parts: [0, [0x2225, '-smallop']]},
      0x2190: {dir: 'H', sizes: 1, parts: [[0x2194, '-smallop'], [0x2190, '-smallop']]},
      0x2191: {dir: 'V', sizes: 1, parts: [[0x2191, '-smallop'], [0x23D0, '-smallop']]},
      0x2192: {dir: 'H', sizes: 1, parts: [0, [0x2190, '-smallop'], [0x2192, '-smallop']]},
      0x2193: {dir: 'V', sizes: 1, parts: [0, [0x23D0, '-smallop'], [0x2193, '-smallop']]},
      0x2194: {dir: 'H', sizes: 1, parts: [[0x2194, '-smallop'], [0x2190, '-smallop'], [0x2192, '-smallop']]},
      0x2195: {dir: 'V', sizes: 1, parts: [[0x2191, '-smallop'], [0x23D0, '-smallop'], [0x2193, '-smallop']]},
      0x219E: {dir: 'H', sizes: 1, parts: [[0x219E, '-smallop'], [0x2190, '-smallop']]},
      0x21A0: {dir: 'H', sizes: 1, parts: [0, [0x2190, '-smallop'], [0x2212, '-smallop']]},
      0x21A4: {dir: 'H', sizes: 1, parts: [[0x2194, '-smallop'], [0x2212, '-smallop'], [0x21A4, '-smallop']]},
      0x21A5: {dir: 'V', sizes: 1, parts: [[0x2191, '-smallop'], [0x23D0, '-smallop'], [0x2017, 'normal']]},
      0x21A6: {dir: 'H', sizes: 1, parts: [[0x21A4, '-smallop'], [0x2212, '-smallop'], [0x2192, '-smallop']]},
      0x21A7: {dir: 'V', sizes: 1, parts: [[0x2017, 'normal'], [0x23D0, '-smallop'], [0x2193, '-smallop']]},
      0x21BC: {dir: 'H', sizes: 1, parts: [[0x21BC, '-smallop'], [0x2190, '-smallop']]},
      0x21BD: {dir: 'H', sizes: 1, parts: [[0x21BD, '-smallop'], [0x2190, '-smallop']]},
      0x21BE: {dir: 'V', sizes: 1, parts: [[0x21BE, 'normal'], [0x21BE, '-smallop']]},
      0x21BF: {dir: 'V', sizes: 1, parts: [[0x21BF, 'normal'], [0x21BE, '-smallop']]},
      0x21C0: {dir: 'H', sizes: 1, parts: [0, [0x2190, '-smallop'], [0x21C0, '-smallop']]},
      0x21C1: {dir: 'H', sizes: 1, parts: [0, [0x2190, '-smallop'], [0x21C1, '-smallop']]},
      0x21C2: {dir: 'V', sizes: 1, parts: [0, [0x21BE, '-smallop'], [0x21C2, 'normal']]},
      0x21C3: {dir: 'V', sizes: 1, parts: [0, [0x21BE, '-smallop'], [0x21C3, 'normal']]},
      0x21D0: {dir: 'H', sizes: 1, parts: [[0x21D4, '-smallop'], [0x21D0, '-smallop']]},
      0x21D1: {dir: 'V', sizes: 1, parts: [[0x21D1, '-smallop'], [0x2016, '-smallop']]},
      0x21D2: {dir: 'H', sizes: 1, parts: [0, [0x21D0, '-smallop'], [0x21D2, '-smallop']]},
      0x21D3: {dir: 'V', sizes: 1, parts: [0, [0x2016, '-smallop'], [0x21D3, '-smallop']]},
      0x21D4: {dir: 'H', sizes: 1, parts: [[0x21D4, '-smallop'], [0x21D0, '-smallop'], [0x21D2, '-smallop']]},
      0x21D5: {dir: 'V', sizes: 1, parts: [[0x21D1, '-smallop'], [0x2016, '-smallop'], [0x21D3, '-smallop']]},
      0x21DA: {dir: 'H', sizes: 1, parts: [[0x21DA, '-smallop'], [0x2261, '-smallop']]},
      0x21DB: {dir: 'H', sizes: 1, parts: [0, [0x2261, '-smallop'], [0x21DB, '-smallop']]},
      0x2212: {dir: 'H', sizes: 1, parts: [0, [0x2212, 'normal']]},
      0x221A: {dir: 'V', sizes: 5, parts: [0xE001, 0xE000, 0x23B7]},
      0x2223: {dir: 'V', sizes: 1, parts: [0, [0x2223, '-smallop']]},
      0x2225: {dir: 'V', sizes: 1, parts: [0, [0x2225, '-smallop']]},
      0x2308: {dir: 'V', sizes: 5, parts: [0x23A1, 0x23A2]},
      0x2309: {dir: 'V', sizes: 5, parts: [0x23A4, 0x23A5]},
      0x230A: {dir: 'V', sizes: 5, parts: [0, 0x23A2, 0x23A3]},
      0x230B: {dir: 'V', sizes: 5, parts: [0, 0x23A5, 0x23A6]},
      0x23AA: {dir: 'V', sizes: 1, parts: [0, 0x23AA, 0]},
      0x23B0: {dir: 'V', sizes: 1, parts: [0x23A7, 0x23AA, 0x23AD]},
      0x23B1: {dir: 'V', sizes: 1, parts: [0x23AB, 0x23AA, 0x23A9]},
      0x23B4: {dir: 'H', min: 1, parts: [[0x250C, 'normal'], [0x23B4, '-smallop'], [0x2510, 'normal']]},
      0x23B5: {dir: 'H', min: 1, parts: [[0x2514, 'normal'], [0x23B5, '-smallop'], [0x2518, 'normal']]},
      0x23D0: {dir: 'V', sizes: 1, parts: [0, [0x2223, '-smallop']]},
      0x23DC: {dir: 'H', sizes: 1, parts: [0xE150, 0xE154, 0xE151], schar: [0x2322]},
      0x23DD: {dir: 'H', sizes: 1, parts: [0xE152, 0xE154, 0xE153], schar: [0x2323]},
      0x23DE: {dir: 'H', sizes: 1, parts: [0xE150, 0xE154, 0xE151, 0xE155]},
      0x23DF: {dir: 'H', sizes: 1, parts: [0xE152, 0xE154, 0xE153, 0xE156]},
      0x27E8: {dir: 'V', sizes: 5},
      0x27E9: {dir: 'V', sizes: 5},
      0x27EE: {dir: 'V', sizes: 1, parts: [0x23A7, 0x23AA, 0x23A9]},
      0x27EF: {dir: 'V', sizes: 1, parts: [0x23AB, 0x23AA, 0x23AD]},
      0x2906: {dir: 'H', sizes: 1, parts: [[0x21D4, '-smallop'], [0x2906, '-smallop'], [0x21A4, '-smallop']]},
      0x2907: {dir: 'H', sizes: 1, parts: [[0x21A4, '-smallop'], [0x2906, '-smallop'], [0x21D2, '-smallop']]},
      0x294A: {dir: 'H', sizes: 1, parts: [[0x21BC, '-smallop'], [0x2190, '-smallop'], [0x21C1, '-smallop']]},
      0x294B: {dir: 'H', sizes: 1, parts: [[0x21BD, '-smallop'], [0x2190, '-smallop'], [0x21C0, '-smallop']]},
      0x294C: {dir: 'V', sizes: 1, parts: [[0x21BE, 'normal'], [0x21BE, '-smallop'], [0x21C3, 'normal']]},
      0x294D: {dir: 'V', sizes: 1, parts: [[0x21BF, 'normal'], [0x21BE, '-smallop'], [0x21C2, 'normal']]},
      0x294E: {dir: 'H', sizes: 1, parts: [[0x21BC, '-smallop'], [0x2190, '-smallop'], [0x21C0, '-smallop']]},
      0x294F: {dir: 'V', sizes: 1, parts: [[0x21BE, 'normal'], [0x21BE, '-smallop'], [0x21C2, 'normal']]},
      0x2950: {dir: 'H', sizes: 1, parts: [[0x21BD, '-smallop'], [0x2190, '-smallop'], [0x21C1, '-smallop']]},
      0x2951: {dir: 'V', sizes: 1, parts: [[0x21BF, 'normal'], [0x21BE, '-smallop'], [0x21C3, 'normal']]},
      0x295A: {dir: 'H', sizes: 1, parts: [[0x21BC, '-smallop'], [0x2212, '-smallop'], [0x21A4, '-smallop']]},
      0x295B: {dir: 'H', sizes: 1, parts: [[0x21A4, '-smallop'], [0x2212, '-smallop'], [0x21C0, '-smallop']]},
      0x295C: {dir: 'V', sizes: 1, parts: [[0x21BE, 'normal'], [0x294C, '-smallop'], [0x2017, 'normal']]},
      0x295D: {dir: 'V', sizes: 1, parts: [[0x2017, 'normal'], [0x294C, '-smallop'], [0x21C2, 'normal']]},
      0x295E: {dir: 'H', sizes: 1, parts: [[0x21BD, '-smallop'], [0x2212, '-smallop'], [0x21A4, '-smallop']]},
      0x295F: {dir: 'H', sizes: 1, parts: [[0x21A4, '-smallop'], [0x2212, '-smallop'], [0x21C1, '-smallop']]},
      0x2960: {dir: 'V', sizes: 1, parts: [[0x21BF, 'normal'], [0x294C, '-smallop'], [0x2017, 'normal']]},
      0x2961: {dir: 'V', sizes: 1, parts: [[0x2017, 'normal'], [0x294C, '-smallop'], [0x21C3, 'normal']]}
    },
    alias: {
      0x002D: 0x2212,
      0x005E: 0x02C6,
      0x005F: 0x2013,
      0x007E: 0x02DC,
      0x02C9: 0x00AF,
      0x0302: 0x02C6,
      0x0303: 0x02DC,
      0x0332: 0x2013,
      0x2014: 0x2013,
      0x2015: 0x2013,
      0x2017: 0x2013,
      0x203E: 0x00AF,
      0x20D7: 0x2192,
      0x2215: 0x002F,
      0x2312: 0x23DC,
      0x2322: 0x23DC,
      0x2323: 0x23DD,
      0x2329: 0x27E8,
      0x232A: 0x27E9,
      0x23AF: 0x2013,
      0x2500: 0x2013,
      0x2758: 0x2223,
      0x27F5: 0x2190,
      0x27F6: 0x2192,
      0x27F7: 0x2194,
      0x27F8: 0x21D0,
      0x27F9: 0x21D2,
      0x27FA: 0x21D4,
      0x27FB: 0x21A4,
      0x27FC: 0x21A6,
      0x27FD: 0x2906,
      0x27FE: 0x2907,
      0x3008: 0x27E8,
      0x3009: 0x27E9,
      0xFE37: 0x23DE,
      0xFE38: 0x23DF
    },
    fullExtenders: {0x221A: [.605, .625 + .935]}
  });

  /***********************************************************************************/

  const MathJaxTexData: FontDef = {
    name: 'MathJaxTex',
    prefix: 'TEX',
    variants: MathJaxTexVariants,
    delimiters: MathJaxTexDelimiters,
    legal: {
      copyright: 'Copyright (c) 2022, MathJax, Inc. (&lt;www.mathjax.org&gt;)',
      license: SIL_LICENSE,
      licenseURL: SIL_URL,
    }
  };

  CommonFont.define(MathJaxTexData).writeFont();

  SVGFont.define(MathJaxTexData).writeFont();
  Components.define('svg', MathJaxTexData).writeFont().writeComponent();

  CHTMLFont.define(MathJaxTexData).writeFont().makeWoffFonts('TEX-N');
  Components.define('chtml', MathJaxTexData).writeFont().writeComponent();

} catch (err) {
  console.log(err);
  process.exit(1);
}
